Index: src/unittests/periodentafelTest.hpp
===================================================================
--- src/unittests/periodentafelTest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/periodentafelTest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -31,6 +31,6 @@
 private:
 
-      element *hydrogen;
-      element *carbon;
+      const element *hydrogen;
+      const element *carbon;
       periodentafel *tafel;
 
Index: src/unittests/stackclassunittest.cpp
===================================================================
--- src/unittests/stackclassunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/stackclassunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -13,5 +18,5 @@
 
 #include "stackclassunittest.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 
 #ifdef HAVE_TESTRUNNER
Index: src/unittests/tesselation_boundarytriangleunittest.cpp
===================================================================
--- src/unittests/tesselation_boundarytriangleunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/tesselation_boundarytriangleunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 using namespace std;
 
@@ -13,7 +18,12 @@
 
 #include <cstring>
+#include <iostream>
 
 #include "defs.hpp"
-#include "tesselation.hpp"
+#include "TesselPoint.hpp"
+#include "BoundaryPointSet.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryTriangleSet.hpp"
+#include "CandidateForTesselation.hpp"
 #include "tesselation_boundarytriangleunittest.hpp"
 
@@ -22,5 +32,5 @@
 #endif /*HAVE_TESTRUNNER*/
 
-#define SPHERERADIUS 2.
+const double TesselationBoundaryTriangleTest::SPHERERADIUS=2.;
 
 /********************************************** Test classes **************************************/
@@ -36,15 +46,15 @@
   // create nodes
   tesselpoints[0] = new TesselPoint;
-  tesselpoints[0]->node = new Vector(0., 0., 0.);
+  tesselpoints[0]->setPosition(Vector(0., 0., 0.));
   tesselpoints[0]->setName("1");
   tesselpoints[0]->nr = 1;
   points[0] = new BoundaryPointSet(tesselpoints[0]);
   tesselpoints[1] = new TesselPoint;
-  tesselpoints[1]->node = new Vector(0., 1., 0.);
+  tesselpoints[1]->setPosition(Vector(0., 1., 0.));
   tesselpoints[1]->setName("2");
   tesselpoints[1]->nr = 2;
   points[1] = new BoundaryPointSet(tesselpoints[1]);
   tesselpoints[2] = new TesselPoint;
-  tesselpoints[2]->node = new Vector(1., 0., 0.);
+  tesselpoints[2]->setPosition(Vector(1., 0., 0.));
   tesselpoints[2]->setName("3");
   tesselpoints[2]->nr = 3;
@@ -67,5 +77,4 @@
   for (int i=0;i<3;++i) {
     // TesselPoint does not delete its vector as it only got a reference
-    delete tesselpoints[i]->node;
     delete tesselpoints[i];
   }
@@ -83,9 +92,9 @@
   // simple test on y line
   Point = Vector(-1.,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(-4.,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( 16., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 16., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -93,9 +102,9 @@
   // simple test on x line
   Point = Vector(0.5,-1.,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(0.5,-6.,0.);
-  CPPUNIT_ASSERT_EQUAL( 36., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 36., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -103,9 +112,9 @@
   // simple test on slanted line
   Point = Vector(1.,1.,0.);
-  CPPUNIT_ASSERT_EQUAL( 0.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 0.5, triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(5.,5.,0.);
-  CPPUNIT_ASSERT_EQUAL( 40.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 40.5, triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -113,5 +122,5 @@
   // simple test on first node
   Point = Vector(-1.,-1.,0.);
-  CPPUNIT_ASSERT_EQUAL( 2., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 2., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -119,5 +128,5 @@
   // simple test on second node
   Point = Vector(0.,2.,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,1.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -125,5 +134,5 @@
   // simple test on third node
   Point = Vector(2.,0.,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(1.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -139,9 +148,9 @@
   // straight down/up
   Point = Vector(1./3.,1./3.,+5.);
-  CPPUNIT_ASSERT_EQUAL( 25. , triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 25. , triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(1./3.,1./3.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(1./3.,1./3.,-5.);
-  CPPUNIT_ASSERT_EQUAL( 25. , triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 25. , triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(1./3.,1./3.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -149,9 +158,9 @@
   // simple test on y line
   Point = Vector(-1.,0.5,+2.);
-  CPPUNIT_ASSERT_EQUAL( 5., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 5., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(-1.,0.5,-3.);
-  CPPUNIT_ASSERT_EQUAL( 10., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 10., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -159,9 +168,9 @@
   // simple test on x line
   Point = Vector(0.5,-1.,+1.);
-  CPPUNIT_ASSERT_EQUAL( 2., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 2., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(0.5,-1.,-2.);
-  CPPUNIT_ASSERT_EQUAL( 5., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 5., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -169,9 +178,9 @@
   // simple test on slanted line
   Point = Vector(1.,1.,+3.);
-  CPPUNIT_ASSERT_EQUAL( 9.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 9.5, triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
   Point = Vector(1.,1.,-4.);
-  CPPUNIT_ASSERT_EQUAL( 16.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 16.5, triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.5,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -179,5 +188,5 @@
   // simple test on first node
   Point = Vector(-1.,-1.,5.);
-  CPPUNIT_ASSERT_EQUAL( 27., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 27., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -185,5 +194,5 @@
   // simple test on second node
   Point = Vector(0.,2.,5.);
-  CPPUNIT_ASSERT_EQUAL( 26., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 26., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(0.,1.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
@@ -191,5 +200,5 @@
   // simple test on third node
   Point = Vector(2.,0.,5.);
-  CPPUNIT_ASSERT_EQUAL( 26., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  CPPUNIT_ASSERT_EQUAL( 26., triangle->GetClosestPointInsideTriangle(Point, TestIntersection) );
   Point = Vector(1.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
Index: src/unittests/tesselation_boundarytriangleunittest.hpp
===================================================================
--- src/unittests/tesselation_boundarytriangleunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/tesselation_boundarytriangleunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -16,4 +16,6 @@
 #include "tesselation.hpp"
 
+class TesselPoint;
+
 /********************************************** Test classes **************************************/
 
@@ -32,4 +34,6 @@
 
 private:
+      static const double SPHERERADIUS;
+
       class BoundaryTriangleSet *triangle;
       class BoundaryLineSet *lines[3];
Index: src/unittests/tesselation_insideoutsideunittest.cpp
===================================================================
--- src/unittests/tesselation_insideoutsideunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/tesselation_insideoutsideunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -13,8 +18,13 @@
 
 #include <cstring>
+#include <iostream>
 
 #include "defs.hpp"
-#include "tesselation.hpp"
+#include "TesselPoint.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryTriangleSet.hpp"
+#include "CandidateForTesselation.hpp"
 #include "tesselation_insideoutsideunittest.hpp"
+#include "Helpers/Verbose.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -22,5 +32,5 @@
 #endif /*HAVE_TESTRUNNER*/
 
-#define SPHERERADIUS 2.
+const double TesselationInOutsideTest::SPHERERADIUS=2.;
 
 /********************************************** Test classes **************************************/
@@ -28,5 +38,4 @@
 // Registers the fixture into the 'registry'
 CPPUNIT_TEST_SUITE_REGISTRATION( TesselationInOutsideTest );
-
 
 void TesselationInOutsideTest::setUp()
@@ -37,40 +46,40 @@
   class TesselPoint *Walker;
   Walker = new TesselPoint;
-  Walker->node = new Vector(0., 0., 0.);
+  Walker->setPosition(Vector(0., 0., 0.));
   Walker->setName("1");
   Walker->nr = 1;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(0., 1., 0.);
+  Walker->setPosition(Vector(0., 1., 0.));
   Walker->setName("2");
   Walker->nr = 2;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(1., 0., 0.);
+  Walker->setPosition(Vector(1., 0., 0.));
   Walker->setName("3");
   Walker->nr = 3;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(1., 1., 0.);
+  Walker->setPosition(Vector(1., 1., 0.));
   Walker->setName("4");
   Walker->nr = 4;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(0., 0., 1.);
+  Walker->setPosition(Vector(0., 0., 1.));
   Walker->setName("5");
   Walker->nr = 5;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(0., 1., 1.);
+  Walker->setPosition(Vector(0., 1., 1.));
   Walker->setName("6");
   Walker->nr = 6;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(1., 0., 1.);
+  Walker->setPosition(Vector(1., 0., 1.));
   Walker->setName("7");
   Walker->nr = 7;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(1., 1., 1.);
+  Walker->setPosition(Vector(1., 1., 1.));
   Walker->setName("8");
   Walker->nr = 8;
@@ -129,8 +138,6 @@
   delete(LinkedList);
   delete(TesselStruct);
-  for (LinkedCell::LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++) {
-    delete((*Runner)->node);
+  for (LinkedCell::LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++)
     delete(*Runner);
-  }
   Corners.clear();
   logger::purgeInstance();
Index: src/unittests/tesselation_insideoutsideunittest.hpp
===================================================================
--- src/unittests/tesselation_insideoutsideunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/tesselation_insideoutsideunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -30,4 +30,6 @@
 
 private:
+      static const double SPHERERADIUS;
+
       class Tesselation *TesselStruct;
       LinkedCell::LinkedNodes Corners;
Index: src/unittests/tesselationunittest.cpp
===================================================================
--- src/unittests/tesselationunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/tesselationunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,8 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -16,5 +20,8 @@
 
 #include "defs.hpp"
-#include "tesselation.hpp"
+#include "TesselPoint.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryTriangleSet.hpp"
+#include "CandidateForTesselation.hpp"
 #include "tesselationunittest.hpp"
 
@@ -23,5 +30,5 @@
 #endif /*HAVE_TESTRUNNER*/
 
-#define SPHERERADIUS 2.
+const double TesselationTest::SPHERERADIUS=2.;
 
 /********************************************** Test classes **************************************/
@@ -36,20 +43,20 @@
   class TesselPoint *Walker;
   Walker = new TesselPoint;
-  Walker->node = new Vector(1., 0., -1.);
+  Walker->setPosition(Vector(1., 0., -1.));
   Walker->setName("1");
   Walker->nr = 1;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(-1., 1., -1.);
+  Walker->setPosition(Vector(-1., 1., -1.));
   Walker->setName("2");
   Walker->nr = 2;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(-1., -1., -1.);
+  Walker->setPosition(Vector(-1., -1., -1.));
   Walker->setName("3");
   Walker->nr = 3;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
-  Walker->node = new Vector(-1., 0., 1.);
+  Walker->setPosition(Vector(-1., 0., 1.));
   Walker->setName("4");
   Walker->nr = 4;
@@ -101,8 +108,6 @@
   delete(LinkedList);
   delete(TesselStruct);
-  for (LinkedCell::LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++) {
-    delete((*Runner)->node);
+  for (LinkedCell::LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++)
     delete(*Runner);
-  }
   Corners.clear();
   logger::purgeInstance();
Index: src/unittests/tesselationunittest.hpp
===================================================================
--- src/unittests/tesselationunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/tesselationunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -33,4 +33,6 @@
 
 private:
+      static const double SPHERERADIUS;
+
       class Tesselation *TesselStruct;
       LinkedCell::LinkedNodes Corners;
Index: src/unittests/vectorunittest.cpp
===================================================================
--- src/unittests/vectorunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/vectorunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,8 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -14,11 +18,11 @@
 
 #include "defs.hpp"
-#include "log.hpp"
-#include "memoryusageobserver.hpp"
-#include "vector.hpp"
-#include "vector_ops.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/vector_ops.hpp"
 #include "vectorunittest.hpp"
-#include "Plane.hpp"
+#include "LinearAlgebra/Plane.hpp"
 #include "Exceptions/LinearDependenceException.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -52,4 +56,53 @@
   errorLogger::purgeInstance();
 };
+
+/** UnitTest for Constructors and Vector::IsZero() and Vector::IsOne().
+ */
+void VectorTest::AssignmentTest()
+{
+  // test with zero
+  zero.at(0) = 0;
+  zero.at(1) = 0;
+  zero.at(2) = 0;
+  double zero_array[3] = {0., 0., 0.};
+
+  CPPUNIT_ASSERT_EQUAL( zero, Vector(0,0,0));
+  CPPUNIT_ASSERT_EQUAL( zero, Vector(0.,0.,0.));
+  CPPUNIT_ASSERT_EQUAL( zero, Vector(zero_array[0], zero_array[1], zero_array[2]));
+  CPPUNIT_ASSERT_EQUAL( zero, Vector(zero_array));
+
+  // test with unit
+  unit.at(0) = 1;
+  unit.at(1) = 0;
+  unit.at(2) = 0;
+  double unit_array[3] = {1., 0., 0.};
+
+  CPPUNIT_ASSERT_EQUAL( unit, Vector(1,0,0));
+  CPPUNIT_ASSERT_EQUAL( unit, Vector(1.,0.,0.));
+  CPPUNIT_ASSERT_EQUAL( unit, Vector(unit_array[0], unit_array[1], unit_array[2]));
+  CPPUNIT_ASSERT_EQUAL( unit, Vector(unit_array));
+
+  // test with two
+  two.at(0) = 2;
+  two.at(1) = 1;
+  two.at(2) = 0;
+  double two_array[3] = {2., 1., 0.};
+
+  CPPUNIT_ASSERT_EQUAL( two, Vector(2,1,0));
+  CPPUNIT_ASSERT_EQUAL( two, Vector(2.,1.,0.));
+  CPPUNIT_ASSERT_EQUAL( two, Vector(two_array[0], two_array[1], two_array[2]));
+  CPPUNIT_ASSERT_EQUAL( two, Vector(two_array));
+
+  // test with three
+  three.at(0) = 1;
+  three.at(1) = 2;
+  three.at(2) = 3;
+  double three_array[3] = {1., 2., 3.};
+
+  CPPUNIT_ASSERT_EQUAL( three, Vector(1,2,3));
+  CPPUNIT_ASSERT_EQUAL( three, Vector(1.,2.,3.));
+  CPPUNIT_ASSERT_EQUAL( three, Vector(three_array[0], three_array[1], three_array[2]));
+  CPPUNIT_ASSERT_EQUAL( three, Vector(three_array));
+}
 
 /** UnitTest for Constructors and Vector::IsZero() and Vector::IsOne().
@@ -214,36 +267,2 @@
   CPPUNIT_ASSERT(testVector.ScalarProduct(three) < MYEPSILON);
 }
-
-
-/**
- * UnitTest for Vector::IsInParallelepiped().
- */
-void VectorTest::IsInParallelepipedTest()
-{
-  double parallelepiped[NDIM*NDIM];
-  parallelepiped[0] = 1;
-  parallelepiped[1] = 0;
-  parallelepiped[2] = 0;
-  parallelepiped[3] = 0;
-  parallelepiped[4] = 1;
-  parallelepiped[5] = 0;
-  parallelepiped[6] = 0;
-  parallelepiped[7] = 0;
-  parallelepiped[8] = 1;
-
-  fixture = zero;
-  CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture = Vector(2.5,2.5,2.5);
-  CPPUNIT_ASSERT_EQUAL( true, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture = Vector(1.,1.,1.);
-  CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture = Vector(3.5,3.5,3.5);
-  CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture = Vector(2.,2.,2.);
-  CPPUNIT_ASSERT_EQUAL( true, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture = Vector(2.,3.,2.);
-  CPPUNIT_ASSERT_EQUAL( true, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture = Vector(-2.,2.,-1.);
-  CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-}
-
Index: src/unittests/vectorunittest.hpp
===================================================================
--- src/unittests/vectorunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/vectorunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 /********************************************** Test classes **************************************/
@@ -18,4 +18,5 @@
 {
     CPPUNIT_TEST_SUITE( VectorTest) ;
+    CPPUNIT_TEST ( AssignmentTest );
     CPPUNIT_TEST ( UnityTest );
     CPPUNIT_TEST ( SimpleAlgebraTest );
@@ -27,5 +28,4 @@
     CPPUNIT_TEST ( ProjectionTest );
     CPPUNIT_TEST ( NormalsTest );
-    CPPUNIT_TEST ( IsInParallelepipedTest );
     CPPUNIT_TEST_SUITE_END();
 
@@ -34,4 +34,5 @@
     void tearDown();
 
+    void AssignmentTest();
     void UnityTest();
     void OperatorAlgebraTest();
@@ -45,5 +46,4 @@
     void LineIntersectionTest();
     void VectorRotationTest();
-    void IsInParallelepipedTest();
 
 private:
Index: test_all.sh
===================================================================
--- test_all.sh	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ test_all.sh	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -21,6 +21,14 @@
 outfile="test.log";
 logfile="full.log";
+noprocs=1;
 docheck=0;
 docheck_mem=0;
+if [ -n "$TMPDIR" ]
+then
+  tmpdir="$TMPDIR";
+else
+  tmpdir="/tmp";
+fi
+tmppattern="MolecuilderTest";
 
 function usage(){
@@ -33,10 +41,13 @@
   echo "  -o <outfile>		Outfile to use for test results";
   echo "  -f <logfile>		File to use for output from commands";
+  echo "  -j <no_proc>          Parallel compiling and tests";
   echo "  -s			Short tests (no memcheck)";
   echo "  -c            	Only configure and compile (implies -s)";
   echo "  -O <opt-level>	Only compile this optimization level";
-}
-
-while getopts âho:f:scO:â OPTION
+  echo "  -t <tmpDir>          	Use tmpDir as temporary directory";
+  echo "  -p <prefix>		Prefix to use for directory names (standard MolecuilderTest)";
+}
+
+while getopts âho:f:j:scO:t:p:â OPTION
 do
   case $OPTION in
@@ -46,8 +57,11 @@
       ;;
    o)
-     outfile=$OPTARG;
+     outfile="$OPTARG";
      ;;
    f)
-     logfile=$OPTARG;
+     logfile="$OPTARG";
+     ;;
+   j)
+     noprocs=("$OPTARG");
      ;;
    s)
@@ -61,4 +75,10 @@
      optimizations=("-O$OPTARG");
      ;;
+   t)
+     tmpdir="$OPTARG";
+     ;;
+   p)
+     tmppattern="$OPTARG";
+     ;;
    ?)
      usage;
@@ -68,5 +88,6 @@
 done
 
-if [[ -z $outfile ]] || [[ -z $logfile ]]
+# test if all arguments were provided
+if [[ -z "$outfile" ]] || [[ -z "$logfile" ]] || [[ -z "$tmpdir" ]] || [[ -z "$tmppattern" ]]
 then
   usage;
@@ -74,6 +95,8 @@
 fi
 
+# turn all relative paths into absolutes
 outfile=`realpath -s $outfile`;
 logfile=`realpath -s $logfile`;
+tmpdir=`realpath -s $tmpdir`;
 
 
@@ -87,10 +110,18 @@
 function compile(){
   echo "Making";
-  make all install >>$logfile 2>&1;
+  if [ $noprocs -gt 1 ]; then
+    make -j$noprocs all >>$logfile 2>&1;
+  else
+    make all >>$logfile 2>&1;
+  fi
 }
 
 function check(){
   echo "Checking";
-  make check >> $logfile 2>&1;
+  if [ $noprocs -gt 1 ]; then
+    make -j$noprocs check >> $logfile 2>&1;
+  else
+    make check >> $logfile 2>&1;
+  fi
 }
 
@@ -98,5 +129,5 @@
   echo "Valgrinding";
   retval=0;
-  for test in molecuilder/src/unittests/*
+  for test in src/unittests/*
   do
     if [ -x "$test" ]
@@ -104,5 +135,5 @@
       echo -n "    $test: " >> $outfile;
       valgrind -v --error-exitcode=255 $test >> $logfile 2>&1;
-      if $?
+      if [ $? ]
       then
       	echo "OK" >> $outfile
@@ -119,4 +150,8 @@
 
   echo "Testing with \"$2\"";
+  echo "" >> $logfile;
+  echo "" >> $logfile;
+  echo "" >> $logfile;
+  echo "Testing with \"$2\"" >> $logfile;
 
   echo -n "  Configuring: " >> $outfile;
@@ -167,5 +202,5 @@
 function run(){
   echo "Testing with \"$1\":" >> $outfile;
-  testdir=`mktemp -d --tmpdir MolecuilderTest.XXXXXXXXXX`;
+  testdir=`mktemp -d --tmpdir=$tmpdir $tmppattern.XXXXXXXXXX`;
   basedir=$PWD;
   cd $testdir;
Index: tests/Tesselations/Makefile.am
===================================================================
--- tests/Tesselations/Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ tests/Tesselations/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -1,15 +1,17 @@
-TESTS = 1_2-dimethoxyethane.test \
-1_2-dimethylbenzene.test \
-2-methylcyclohexanone.test \
-benzene.test \
-cholesterol.test \
-cycloheptane.test \
-dimethyl_bromomalonate.test \
-glucose.test \
-heptan.test \
-isoleucine.test \
-neohexane.test \
-N_N-dimethylacetamide.test \
-proline.test \
-putrescine.test \
-tartaric_acid.test
+TESTS = \
+	1_2-dimethoxyethane.test \
+	1_2-dimethylbenzene.test \
+	2-methylcyclohexanone.test \
+	benzene.test \
+	cholesterol.test \
+	cycloheptane.test \
+	dimethyl_bromomalonate.test \
+	glucose.test \
+	isoleucine.test \
+	neohexane.test \
+	N_N-dimethylacetamide.test \
+	proline.test \
+	putrescine.test \
+	tartaric_acid.test
+
+#	heptan.test
Index: tests/Tesselations/defs.in
===================================================================
--- tests/Tesselations/defs.in	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ tests/Tesselations/defs.in	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -54,18 +54,18 @@
 	#echo "Current dir is `pwd`, calling $MOLECUILDER $mol.conf -e $exec_prefix -p ../$mol.xyz -N $RADIUS $FILENAME."
 	if [ -e $mol.dbond ]; then
-		$MOLECUILDER $mol.conf -e $exec_prefix -p ../$mol.xyz -A $mol.dbond -N 0 --sphere-radius $RADIUS --nonconvex-file $FILENAME 2>stderr >stdout || exitcode=$?
+		$MOLECUILDER -i ../$mol.xyz -A $mol.dbond --select-molecule-by-id 0 -N $RADIUS --nonconvex-file $FILENAME 2>stderr >stdout || exitcode=$?
 	else
-		$MOLECUILDER $mol.conf -e $exec_prefix -p ../$mol.xyz -N 0 --sphere-radius $RADIUS --nonconvex-file $FILENAME 2>stderr >stdout || exitcode=$?
+		$MOLECUILDER -i ../$mol.xyz --select-molecule-by-id 0 -N $RADIUS --nonconvex-file $FILENAME 2>stderr >stdout || exitcode=$?
 	fi
 	#echo "Molecuilder done with exitcode $exitcode."
+	cd ../..
 	#cat stderr
 	#cat stdout
-        grep -E "^[0-9]* [0-9]* [0-9]*$" ../../@srcdir@/$mol/$2/${FILENAME}-$mol.dat | sort -n >reference-triangles.dat
-        grep -E "^[0-9]* [0-9]* [0-9]*$" ${FILENAME}.dat | sort -n >new-triangles.dat
-        diff reference-triangles.dat new-triangles.dat 2>diffstderr >diffstdout || exitcode=$?
+        grep -E "^[0-9]* [0-9]* [0-9]*$" @srcdir@/$mol/$2/${FILENAME}-$mol.dat | sort -n >$testdir/$RADIUS/reference-triangles.dat
+        grep -E "^[0-9]* [0-9]* [0-9]*$" $testdir/$RADIUS/${FILENAME}.dat | sort -n >$testdir/$RADIUS/new-triangles.dat
+        diff $testdir/$RADIUS/reference-triangles.dat $testdir/$RADIUS/new-triangles.dat 2>$testdir/$RADIUS/diffstderr >$testdir/$RADIUS/diffstdout || exitcode=$?
 	#echo "Diff done with exitcode $exitcode."
 	#cat diffstderr
 	#cat diffstdout
-	cd ../..
 	test $exitcode = $expected_exitcode || exit 1
 }
Index: tests/regression/Domain/4/post/test.conf
===================================================================
--- tests/regression/Domain/4/post/test.conf	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ tests/regression/Domain/4/post/test.conf	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -47,5 +47,5 @@
 BoxLength			# (Length of a unit cell)
 1	
-0	0	
+0	1	
 0	0	2	
 
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ tests/regression/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -3,28 +3,37 @@
 TESTSUITE = $(srcdir)/testsuite
 
+max_jobs = 4
+ 
 check-local: atconfig atlocal package.m4 $(TESTSUITE)
-		$(SHELL) '$(TESTSUITE)' $(TESTSUITEFLAGS)
+	nrjobs=; \
+	for flag in $$MAKEFLAGS; do \
+		case $$flag in \
+		--* | =*=) ;; \
+		*j*) nrjobs="-j$(max_jobs)" ;; \
+		esac; \
+	done; \
+	$(SHELL) '$(TESTSUITE)' $$nrjobs $(TESTSUITEFLAGS)
 
 installcheck-local: atconfig atlocal $(TESTSUITE)
-		$(SHELL) '$(TESTSUITE)' AUTOTEST_PATH='$(bindir)' \
-		$(TESTSUITEFLAGS)
-     
+	$(SHELL) '$(TESTSUITE)' AUTOTEST_PATH='$(bindir)' \
+	$(TESTSUITEFLAGS)
+
 clean-local:
-		test ! -f '$(TESTSUITE)' || \
-		$(SHELL) '$(TESTSUITE)' --clean
+	test ! -f '$(TESTSUITE)' || \
+	$(SHELL) '$(TESTSUITE)' --clean
 
 AUTOTEST = $(AUTOM4TE) --language=autotest
 $(TESTSUITE): $(srcdir)/testsuite.at $(srcdir)/testsuite-*.at
-		$(AUTOTEST) -I '$(srcdir)' -o $@.tmp $@.at
-		mv $@.tmp $@
+	$(AUTOTEST) -I '$(srcdir)' -o $@.tmp $@.at
+	mv $@.tmp $@
 
 # The `:;' works around a Bash 3.2 bug when the output is not writeable.
 $(srcdir)/package.m4: $(top_srcdir)/configure.ac
-			:;{ \
-					echo '# Signature of the current package.' && \
-					echo 'm4_define([AT_PACKAGE_NAME],      [@PACKAGE_NAME@])' && \
-					echo 'm4_define([AT_PACKAGE_TARNAME],   [@PACKAGE_TARNAME@])' && \
-					echo 'm4_define([AT_PACKAGE_VERSION],   [@PACKAGE_VERSION@])' && \
-					echo 'm4_define([AT_PACKAGE_STRING],    [@PACKAGE_STRING@])' && \
-					echo 'm4_define([AT_PACKAGE_BUGREPORT], [@PACKAGE_BUGREPORT@])'; \
-				} >'$(srcdir)/package.m4'
+	:;{ \
+		echo '# Signature of the current package.' && \
+		echo 'm4_define([AT_PACKAGE_NAME],      [@PACKAGE_NAME@])' && \
+		echo 'm4_define([AT_PACKAGE_TARNAME],   [@PACKAGE_TARNAME@])' && \
+		echo 'm4_define([AT_PACKAGE_VERSION],   [@PACKAGE_VERSION@])' && \
+		echo 'm4_define([AT_PACKAGE_STRING],    [@PACKAGE_STRING@])' && \
+		echo 'm4_define([AT_PACKAGE_BUGREPORT], [@PACKAGE_BUGREPORT@])'; \
+	} >'$(srcdir)/package.m4'
Index: tests/regression/Molecules/10/post/test-rotated-xYz20.xyz
===================================================================
--- tests/regression/Molecules/10/post/test-rotated-xYz20.xyz	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ tests/regression/Molecules/10/post/test-rotated-xYz20.xyz	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.8135	2.37271	3.16085
+H	9.33431	2.65703	4.85139
+H	10.6201	3.64185	4.11314
+H	8.96913	4.62097	2.54339
+H	8.48994	4.90529	4.23393
+H	6.55678	4.15323	2.87536
+H	7.44056	2.67134	2.43801
+H	6.96137	2.95567	4.12855
+C	9.67442	3.13152	3.9309
+C	8.62901	4.14648	3.46388
+C	7.30149	3.43016	3.20806
